/***************************************************************************
 *   Copyright (C) 2008  Antony Martin <martin(dot)antony(at)yahoo(dot)fr> *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 28/02/2008
   derniere modification : 28/02/2008 */

#ifndef SCEPLANE_H
#define SCEPLANE_H

#include <SCE/utils/SCEVector.h>

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct sce_splane SCE_SPlane;
struct sce_splane
{
    SCE_TVector3 n;
    float d;
};

/* initialise un plan */
void SCE_Plane_Init (SCE_SPlane*);

/* defini un plan */
void SCE_Plane_Set (SCE_SPlane*, float, float, float, float);
void SCE_Plane_Setv (SCE_SPlane*, SCE_TVector3, float);

#if 0
/* defini un plan a partir d'une normale et d'un point faisant parti du plan */
void SCE_Plane_SetFromPoint (SCE_SPlane*, SCE_TVector3, float, float, float);
void SCE_Plane_SetFromPointv (SCE_SPlane*, SCE_TVector3, SCE_TVector3);
#endif

/* normalise la normale du plan */
void SCE_Plane_Normalize (SCE_SPlane*, int);

/* retourne la plus courte distance entre en plan et un point */
float SCE_Plane_DistanceToPoint (SCE_SPlane*, float, float, float);
float SCE_Plane_DistanceToPointv (SCE_SPlane*, SCE_TVector3);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* guard */
